﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.ComponentModel;
using Telerik.Windows.Controls.Charting;

namespace SilverlightWithUserControls
{
	public partial class Two : UserControl
	{
		public Two()
		{
			InitializeComponent();

			this.DataContext = new TwoViewModel();
		}

		private void ZoomScrollSettingsX_PropertyChanged(object sender, PropertyChangedEventArgs e)
		{
			if (this.RadChart1 == null)
				return;

			double range = (sender as ZoomScrollSettings).Range;

			if (range > 0.7d)
			{
				RadChart1.DefaultView.ChartArea.AxisX.DefaultLabelFormat = "yyyy";
				RadChart1.DefaultView.ChartArea.AxisX.StepLabelLevelCount = 1;
			}
			else if (range > 1d / 12d)
			{
				RadChart1.DefaultView.ChartArea.AxisX.DefaultLabelFormat = "MMMM yyyy";
				RadChart1.DefaultView.ChartArea.AxisX.StepLabelLevelCount = 2;
			}
			else if (range > 1d / 12d / 30d)
			{
				RadChart1.DefaultView.ChartArea.AxisX.DefaultLabelFormat = "dd MMM yyyy";
				RadChart1.DefaultView.ChartArea.AxisX.StepLabelLevelCount = 2;
			}
			else
			{
				RadChart1.DefaultView.ChartArea.AxisX.DefaultLabelFormat = "dd-MMM (HH:mm)";
				RadChart1.DefaultView.ChartArea.AxisX.StepLabelLevelCount = 2;
			}
		}

		private void OneYear_Click(object sender, RoutedEventArgs e)
		{
			this.SetRange(1d / 12d);
		}

		private void SixMonths_Click(object sender, RoutedEventArgs e)
		{
			this.SetRange(1d / 24d);
		}

		private void OneMonth_Click(object sender, RoutedEventArgs e)
		{
			this.SetRange(1d / 144d);
		}

		private void OneWeek_Click(object sender, RoutedEventArgs e)
		{
			this.SetRange(1d / 625d);
		}

		private void SetRange(double newRange)
		{
			if (RadChart1.DefaultView.ChartArea.ZoomScrollSettingsX.RangeEnd + newRange > 1)
				RadChart1.DefaultView.ChartArea.ZoomScrollSettingsX.SetSelectionRange(1 - newRange, 1);
			else
				RadChart1.DefaultView.ChartArea.ZoomScrollSettingsX.RangeEnd = RadChart1.DefaultView.ChartArea.ZoomScrollSettingsX.RangeStart + newRange;
		}
	}
}
